module.exports = Avatar = () => ({
  ".avatar": {
    "@apply bg-primary-light text-primary": {},
    borderRadius: "9999px",
    display: "flex",
    alignItems: "center",
    justifyContent: "center",
    flexGrow: 0,
    fontWeight: 700,
    height: ["3rem", "100%"],
    fontSize: "1rem",
    lineHeight: "1.5rem",
    position: "relative",
    textAlign: "center",
    textTransform: "uppercase",
    textDecoration: ["none", "none"],
    userSelect: "none",
    width: ["3rem", "100%"],
    maxWidth: "3rem",
    minWidth: "3rem",
    maxHeight: "3rem",
    minHeight: "3rem",
  },
  ".avatar img, .prose .avatar img": {
    borderRadius: "9999px",
    height: "100%",
    marginTop: "0px",
    marginBottom: "0px",
    OObjectFit: "cover",
    objectFit: "cover",
    width: "100%",
  },
  // Indicator
  ".avatar-offline::after, .avatar-online::after, .avatar-busy::after, .avatar-focused::after": {
    content: "''",
    borderRadius: "9999px",
    height: "0.75rem",
    position: "absolute",
    right: "0px",
    bottom: "0px",
    width: "0.75rem",
  },
  ".avatar-offline::after": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(148, 163, 184, var(--tw-bg-opacity))",
  },
  ".avatar-online::after": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(5, 150, 105, var(--tw-bg-opacity))",
  },
  ".avatar-focused::after": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(124, 58, 237, var(--tw-bg-opacity))",
  },
  ".avatar-busy::after": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(220, 38, 38, var(--tw-bg-opacity))",
  },
  // Sizes
  ".avatar svg": { height: "1.5rem", width: "1.5rem" },
  ".avatar-xs": {
    height: "1.5rem !important",
    fontSize: "0.75rem !important",
    lineHeight: "1rem !important",
    width: "1.5rem !important",
    maxWidth: "1.5rem !important",
    minWidth: "1.5rem !important",
    maxHeight: "1.5rem !important",
    minHeight: "1.5rem !important",
  },
  ".avatar-xs svg": {
    height: "0.75rem !important",
    width: "0.75rem !important",
  },
  ".avatar-sm": {
    height: "2rem !important",
    fontSize: "0.875rem !important",
    lineHeight: "1.25rem !important",
    width: "2rem !important",
    maxWidth: "2rem !important",
    minWidth: "2rem !important",
    maxHeight: "2rem !important",
    minHeight: "2rem !important",
  },
  ".avatar-sm svg": { height: "1rem !important", width: "1rem !important" },
  ".avatar-lg": {
    height: "5rem !important",
    fontSize: "1.125rem !important",
    lineHeight: "1.75rem !important",
    width: "5rem !important",
    maxWidth: "5rem !important",
    minWidth: "5rem !important",
    maxHeight: "5rem !important",
    minHeight: "5rem !important",
  },
  ".avatar-lg svg": { height: "2.5rem !important", width: "2.5rem !important" },
  ".avatar-xl": {
    height: "8rem !important",
    fontSize: "1.875rem !important",
    lineHeight: "2.25rem !important",
    width: "8rem !important",
    maxWidth: "8rem !important",
    minWidth: "8rem !important",
    maxHeight: "8rem !important",
    minHeight: "8rem !important",
  },
  ".avatar-xl svg": { height: "4rem !important", width: "4rem !important" },
  // Text
  ".avatar-text": {
    display: "flex",
    alignItems: "center",
    fontWeight: 600,
    "--tw-text-opacity": "1",
    color: "rgba(30, 41, 59, var(--tw-text-opacity))",
    textDecoration: "none",
  },
  ".avatar-text .avatar": { marginRight: "0.5rem" },
  ".prose .avatar-text p": { marginTop: "0px", marginBottom: "0px" },
});
