module.exports = Button = (styles) => ({
  ".btn, .prose a.btn": {
    borderColor: "currentColor",
    borderRadius: "0.375rem",
    cursor: "pointer",
    display: "inline-block",
    fontWeight: 500,
    pointerEvents: "auto",
    textAlign: "center",
    textDecoration: "none",
    userSelect: "none",
    verticalAlign: "middle",
    "--tw-translate-x": "0",
    "--tw-translate-y": "0",
    "--tw-rotate": "0",
    "--tw-skew-x": "0",
    "--tw-skew-y": "0",
    "--tw-scale-x": ["1", "1"],
    "--tw-scale-y": ["1", "1"],
    transform:
      "translateX(var(--tw-translate-x)) translateY(var(--tw-translate-y)) rotate(var(--tw-rotate)) skewX(var(--tw-skew-x)) skewY(var(--tw-skew-y)) scaleX(var(--tw-scale-x)) scaleY(var(--tw-scale-y))",
    transitionProperty: "background-color, border-color, color, fill, stroke, opacity, box-shadow, transform",
    transitionTimingFunction: "cubic-bezier(0.4, 0, 0.2, 1)",
    transitionDuration: "150ms",
    fontSize: "0.95rem",
    paddingTop: "0.45rem",
    paddingBottom: "0.45rem",
    paddingLeft: "0.85rem",
    paddingRight: "0.85rem",
    willChange: "transform",
    backfaceVisibility: "hidden",
  },
  ".btn:focus, .prose a.btn:focus": {
    outline: "2px solid transparent",
    outlineOffset: "2px",
    "--tw-ring-offset-shadow": "var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color)",
    "--tw-ring-shadow": "var(--tw-ring-inset) 0 0 0 calc(3px + var(--tw-ring-offset-width)) var(--tw-ring-color)",
    boxShadow: "var(--tw-ring-offset-shadow), var(--tw-ring-shadow), var(--tw-shadow, 0 0 #0000)",
  },
  ".btn:active, .prose a.btn:active": {
    "--tw-ring-offset-shadow": "var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color)",
    "--tw-ring-shadow": "var(--tw-ring-inset) 0 0 0 calc(0px + var(--tw-ring-offset-width)) var(--tw-ring-color)",
    boxShadow: "var(--tw-ring-offset-shadow), var(--tw-ring-shadow), var(--tw-shadow, 0 0 #0000)",
    "--tw-scale-x": ".95",
    "--tw-scale-y": ".95",
  },
  // Sizes
  ".btn.btn-xs, .prose .btn.btn-xs": {
    fontSize: "0.75rem",
    lineHeight: "1rem",
    paddingTop: "0.15rem",
    paddingBottom: "0.15rem",
    paddingLeft: "0.4rem",
    paddingRight: "0.4rem",
  },
  ".btn.btn-sm, .prose .btn.btn-sm": {
    fontSize: "0.875rem",
    lineHeight: "1.25rem",
    paddingTop: "0.3rem",
    paddingBottom: "0.3rem",
    paddingLeft: "0.65rem",
    paddingRight: "0.65rem",
  },
  ".btn.btn-lg, .prose .btn.btn-lg": {
    fontSize: "1.125rem",
    lineHeight: "1.75rem",
    paddingTop: "0.6rem",
    paddingBottom: "0.6rem",
    paddingLeft: "1.4rem",
    paddingRight: "1.4rem",
  },
  ".btn.btn-xl, .prose .btn.btn-xl": {
    fontSize: "1.25rem",
    lineHeight: "1.75rem",
    paddingTop: "0.9rem",
    paddingBottom: "0.9rem",
    paddingLeft: "1.65rem",
    paddingRight: "1.65rem",
  },
  // Colors
  ".btn-primary, .prose a.btn-primary": {
    "@apply bg-primary hover:bg-primary-dark": {},
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-secondary, .prose a.btn-secondary": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(100, 116, 139, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-secondary:hover, .prose a.btn-secondary:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(51, 65, 85, var(--tw-bg-opacity))",
  },
  ".btn-success, .prose a.btn-success": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(4, 120, 87, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-success:hover, .prose a.btn-success:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(6, 78, 59, var(--tw-bg-opacity))",
  },
  ".btn-danger, .prose a.btn-danger": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(185, 28, 28, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-danger:hover, .prose a.btn-danger:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(127, 29, 29, var(--tw-bg-opacity))",
  },
  ".btn-warning, .prose a.btn-warning": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(217, 119, 6, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-warning:hover, .prose a.btn-warning:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(146, 64, 14, var(--tw-bg-opacity))",
  },
  ".btn-light, .prose a.btn-light": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(241, 245, 249, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(30, 41, 59, var(--tw-text-opacity))",
  },
  ".btn-light:hover, .prose a.btn-light:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(203, 213, 225, var(--tw-bg-opacity))",
  },
  ".btn-dark, .prose a.btn-dark": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(15, 23, 42, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-dark:hover, .prose a.btn-dark:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(51, 65, 85, var(--tw-bg-opacity))",
  },
  ".btn-white, .prose a.btn-white": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(255, 255, 255, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(15, 23, 42, var(--tw-text-opacity))",
  },
  ".btn-white:hover, .prose a.btn-white:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(226, 232, 240, var(--tw-bg-opacity))",
  },
  ".btn-link, .prose a.btn-link": {
    "@apply text-primary-dark": {},
    backgroundColor: "transparent",
  },
  ".btn-link:hover, .prose a.btn-link:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(203, 213, 225, var(--tw-bg-opacity))",
  },
  ".btn-light-primary, .prose a.btn-light-primary": {
    "@apply bg-primary-light text-primary hover:bg-primary hover:text-primary-light": {},
  },
  ".btn-light-secondary, .prose a.btn-light-secondary": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(226, 232, 240, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(51, 65, 85, var(--tw-text-opacity))",
  },
  ".btn-light-secondary:hover, .prose a.btn-light-secondary:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(203, 213, 225, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(15, 23, 42, var(--tw-text-opacity))",
  },
  ".btn-light-success, .prose a.btn-light-success": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(167, 243, 208, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(6, 95, 70, var(--tw-text-opacity))",
  },
  ".btn-light-success:hover, .prose a.btn-light-success:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(110, 231, 183, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(6, 78, 59, var(--tw-text-opacity))",
  },
  ".btn-light-danger, .prose a.btn-light-danger": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(254, 202, 202, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(185, 28, 28, var(--tw-text-opacity))",
  },
  ".btn-light-danger:hover, .prose a.btn-light-danger:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(252, 165, 165, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(127, 29, 29, var(--tw-text-opacity))",
  },
  ".btn-light-warning, .prose a.btn-light-warning": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(253, 230, 138, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(146, 64, 14, var(--tw-text-opacity))",
  },
  ".btn-light-warning:hover, .prose a.btn-light-warning:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(252, 211, 77, var(--tw-bg-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(120, 53, 15, var(--tw-text-opacity))",
  },
  ".btn-light-link, .prose a.btn-light-link": {
    "@apply text-primary-light hover:text-primary": {},
    backgroundColor: "transparent",
  },
  ".btn-light-link:hover, .prose a.btn-light-link:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(226, 232, 240, var(--tw-bg-opacity))",
  },
  ".btn-outline-primary:hover, .prose a.btn-outline-primary:hover": {
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-outline-primary, .prose a.btn-outline-primary": {
    "@apply text-primary hover:bg-primary-dark hover:border-primary-dark": {},
    borderWidth: "1px",
  },
  ".btn-outline-secondary:hover, .prose a.btn-outline-secondary:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(30, 41, 59, var(--tw-bg-opacity))",
    "--tw-border-opacity": "1",
    borderColor: "rgba(30, 41, 59, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-outline-secondary, .prose a.btn-outline-secondary": {
    borderWidth: "1px",
    "--tw-text-opacity": "1",
    color: "rgba(71, 85, 105, var(--tw-text-opacity))",
  },
  ".btn-outline-success:hover, .prose a.btn-outline-success:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(6, 78, 59, var(--tw-bg-opacity))",
    "--tw-border-opacity": "1",
    borderColor: "rgba(6, 78, 59, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-outline-success, .prose a.btn-outline-success": {
    borderWidth: "1px",
    "--tw-text-opacity": "1",
    color: "rgba(4, 120, 87, var(--tw-text-opacity))",
  },
  ".btn-outline-danger:hover, .prose a.btn-outline-danger:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(127, 29, 29, var(--tw-bg-opacity))",
    "--tw-border-opacity": "1",
    borderColor: "rgba(127, 29, 29, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-outline-danger, .prose a.btn-outline-danger": {
    borderWidth: "1px",
    "--tw-text-opacity": "1",
    color: "rgba(185, 28, 28, var(--tw-text-opacity))",
  },
  ".btn-outline-warning:hover, .prose a.btn-outline-warning:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(146, 64, 14, var(--tw-bg-opacity))",
    "--tw-border-opacity": "1",
    borderColor: "rgba(146, 64, 14, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-outline-warning, .prose a.btn-outline-warning": {
    borderWidth: "1px",
    "--tw-text-opacity": "1",
    color: "rgba(217, 119, 6, var(--tw-text-opacity))",
  },
  ".btn-outline-light:hover, .prose a.btn-outline-light:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(148, 163, 184, var(--tw-bg-opacity))",
    "--tw-border-opacity": "1",
    borderColor: "rgba(148, 163, 184, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(15, 23, 42, var(--tw-text-opacity))",
  },
  ".btn-outline-light, .prose a.btn-outline-light": {
    borderWidth: "1px",
    "--tw-text-opacity": "1",
    color: "rgba(226, 232, 240, var(--tw-text-opacity))",
  },
  ".btn-outline-dark:hover, .prose a.btn-outline-dark:hover": {
    "--tw-bg-opacity": "1",
    backgroundColor: "rgba(15, 23, 42, var(--tw-bg-opacity))",
    "--tw-border-opacity": "1",
    borderColor: "rgba(15, 23, 42, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
  },
  ".btn-outline-dark, .prose a.btn-outline-dark": {
    borderWidth: "1px",
    "--tw-text-opacity": "1",
    color: "rgba(15, 23, 42, var(--tw-text-opacity))",
  },
  ".btn-outline-link, .prose a.btn-outline-link": {
    "@apply text-primary-dark": {},
    borderColor: "transparent",
    borderWidth: "1px",
  },
  ".btn-outline-link:hover, .prose a.btn-outline-link:hover": {
    "--tw-border-opacity": "1",
    borderColor: "rgba(203, 213, 225, var(--tw-border-opacity))",
  },
  // Disabled, Loading
  ".btn:disabled": {
    cursor: "not-allowed !important",
    opacity: "0.25 !important",
    pointerEvents: "none !important",
  },
  ".btn-loading": {
    cursor: "wait !important",
    opacity: "0.75 !important",
    pointerEvents: "none !important",
  },
  ".btn-loading .spinner": { marginTop: "-3px" },
  // Icons
  ".btn.btn-icon": {
    display: "inline-flex",
    alignItems: "center",
    justifyContent: "center",
  },
  ".btn-icon.btn-xs": { paddingLeft: "0px", paddingRight: "0px" },
  ".btn-icon.btn-xs svg": { height: "1rem", width: "1rem" },
  ".btn-icon.btn-sm svg": { height: "1rem", width: "1rem" },
  ".btn-icon svg": { height: "1.25rem", width: "1.25rem" },
  ".btn-icon.btn-lg svg": { height: "1.5rem", width: "1.5rem" },
  ".btn-icon.btn-xl svg": { height: "2rem", width: "2rem" },
  // Button List
  ".btn-list": { marginBottom: "-0.5rem" },
  ".btn-list .btn": { marginBottom: "0.5rem" },
  ".btn-list > .btn:not(:last-child)": { marginRight: "0.25rem" },
  // Button Group
  ".btn-group": { display: "inline-flex", verticalAlign: "middle" },
  ".btn-group .btn": { borderRadius: "0px" },
  ".btn-group .btn:focus": { zIndex: 10 },
  ".btn-group .btn:first-child": {
    borderTopLeftRadius: "0.25rem",
    borderBottomLeftRadius: "0.25rem",
  },
  ".btn-group .btn:last-child": {
    borderTopRightRadius: "0.25rem",
    borderBottomRightRadius: "0.25rem",
  },
  // Brand Colors
  ".btn-twitter, .prose a.btn-twitter": {
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
    backgroundColor: "#1da1f2",
  },
  ".btn-twitter:hover, .prose a.btn-twitter:hover": {
    backgroundColor: "#0c80c7",
  },
  ".btn-google, .prose a.btn-google": {
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
    backgroundColor: "#4285f4",
  },
  ".btn-google:hover, .prose a.btn-google:hover": {
    backgroundColor: "#1d61d2",
  },
  ".btn-instagram, .prose a.btn-instagram": {
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
    backgroundColor: "#e1306c",
  },
  ".btn-instagram:hover, .prose a.btn-instagram:hover": {
    backgroundColor: "#bf134d",
  },
  ".btn-github, .prose a.btn-github": {
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
    backgroundColor: "#333",
  },
  ".btn-github:hover, .prose a.btn-github:hover": { backgroundColor: "#000" },
  ".btn-facebook, .prose a.btn-facebook": {
    "--tw-text-opacity": "1",
    color: "rgba(255, 255, 255, var(--tw-text-opacity))",
    backgroundColor: "#3b5998",
  },
  ".btn-facebook:hover, .prose a.btn-facebook:hover": {
    backgroundColor: "#1c3467",
  },
});
