module.exports = Tabs = () => ({
  ".tab": {
    "--tw-border-opacity": "1",
    borderColor: "rgba(226, 232, 240, var(--tw-border-opacity))",
    borderBottomWidth: "1px",
    display: "flex",
    alignItems: "flex-end",
  },
  ".tab-link, .prose .tab-link": {
    "--tw-border-opacity": "1",
    borderColor: "rgba(226, 232, 240, var(--tw-border-opacity))",
    borderBottomWidth: "1px",
    fontWeight: 500,
    fontSize: "0.875rem",
    lineHeight: "1.25rem",
    paddingTop: "0.5rem",
    paddingBottom: "0.5rem",
    paddingLeft: "1rem",
    paddingRight: "1rem",
    textAlign: "center",
    "--tw-text-opacity": "1",
    color: "rgba(71, 85, 105, var(--tw-text-opacity))",
    textDecoration: "none",
    transitionProperty: "background-color, border-color, color, fill, stroke, opacity, box-shadow, transform",
    transitionTimingFunction: "cubic-bezier(0.4, 0, 0.2, 1)",
    transitionDuration: "150ms",
    marginBottom: "-1px",
  },
  ".tab-link:hover, .prose .tab-link:hover": {
    "--tw-border-opacity": "1",
    borderColor: "rgba(148, 163, 184, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(15, 23, 42, var(--tw-text-opacity))",
  },
  ".tab-link:focus, .prose .tab-link:focus": {
    outline: "2px solid transparent",
    outlineOffset: "2px",
    "--tw-ring-offset-shadow": "var(--tw-ring-inset) 0 0 0 var(--tw-ring-offset-width) var(--tw-ring-offset-color)",
    "--tw-ring-shadow": "var(--tw-ring-inset) 0 0 0 calc(3px + var(--tw-ring-offset-width)) var(--tw-ring-color)",
    boxShadow: "var(--tw-ring-offset-shadow), var(--tw-ring-shadow), var(--tw-shadow, 0 0 #0000)",
    zIndex: 10,
  },
  ".tab-link.disabled": {
    cursor: "default",
    opacity: 0.25,
    pointerEvents: "none",
  },
  ".tab-full .tab-link": { width: "100%" },
  // Sizes
  ".tab-sm .tab-link": {
    fontSize: "0.75rem",
    lineHeight: "1rem",
    paddingTop: "0.25rem",
    paddingBottom: "0.25rem",
    paddingLeft: "0.5rem",
    paddingRight: "0.5rem",
  },
  ".tab-lg .tab-link": {
    fontSize: "1.125rem",
    lineHeight: "1.75rem",
    paddingLeft: "1.25rem",
    paddingRight: "1.25rem",
  },
  // Vertical
  ".tab-vertical": {
    borderWidth: "0px",
    flexDirection: "column",
    alignItems: "flex-start",
  },
  ".tab-vertical .tab-link": {
    borderColor: "transparent",
    borderBottomWidth: "0px",
    borderLeftWidth: "1px",
    paddingTop: "0.5rem",
    paddingBottom: "0.5rem",
  },
  ".tab-vertical .tab-link:hover": {
    "--tw-border-opacity": "1",
    borderColor: "rgba(148, 163, 184, var(--tw-border-opacity))",
    "--tw-text-opacity": "1",
    color: "rgba(15, 23, 42, var(--tw-text-opacity))",
  },
  // Active
  ".tab-link.active": {
    "@apply text-primary border-primary hover:text-primary-dark hover:border-primary-dark": {},
  },
});
